
                   (* Data-type and variables unit for XX3401.PAS.          *)
UNIT Xx34Data;

INTERFACE

uses
  Dos;

(******************************* DATA-TYPES *********************************)
type
  Str2 = string[2];
  Str12 = string[12];
  Str27 = string[27];
  Str33 = string[33];
  Str80 = string[80];
  Str255 = string[255];

  FnType = string[12];

  Char2  = array[1..2] of char;
  Char3  = array[1..3] of char;
  Char4  = array[1..4] of char;
  Char5  = array[1..5] of char;
  Char6  = array[1..6] of char;
  Char7  = array[1..7] of char;
  Char9  = array[1..9] of char;
  Char12 = array[1..12] of char;
  Char62 = array[1..62] of char;
  Char64 = array[0..63] of char;

  Char3x2 = array[1..3] of Char2;

  Char2_1 = record
              Num : Char2;
              Dud : char;
            end;

  Char303 = array[1..101] of Char2_1;

  Char3_1 = record
              Num : Char3;
              Dud : char;
            end;

  Char800 = array[1..200] of Char3_1;

  Byte80 = array[43..122] of byte;
  Byte100 = array[0..99] of byte;

  Word99 = array[1..99] of word;

  Long99 = array[1..99] of longint;

  Head1 = array[1..62] of char;

  Head2 = record
            ID       : Char5;
            Version  : Char2;
            Space1   : char;
            Size     : Char6;
            Space2   : char;
            Fday     : Char2;
            Fmonth   : Char2;
            Fyear    : Char2;
            Space3   : char;
            FCols    : Char3;
            Space4   : char;
            FRows    : Char3;
            Space5   : char;
            CrcValue : Char5;
            Space6   : Char4;
            FileName : Char12;
            Block    : Char3;
            Space7   : Char3;
            BlockTot : Char3;
            CrLfPair : Char2;
          end;

  BinBuffType  = array[1..15360] of byte;
  XxBuffType   = array[1..24800] of char;

(******************************* CONSTANTS **********************************)
const
                   (* Column, row default size.                             *)
  ColDefault = 68;
  RowDefault = 85;

                   (* Minimum and maximum column sizes.                     *)
  MinCol = 60;
  MaxCol = 100;

                   (* Minimum and maximum row sizes.                        *)
  MinRow = 10;
  MaxRow = 200;

                   (* Maximum number of XxBlocks allowed.                   *)
  BlockMax = 99;

                   (* XxHeader + XxFooter + CrLf's = XxOverhead per block.  *)
  XxOverHead = 102;

                   (* Just like it says.                                    *)
  OneKay = 1024;

                   (* Large Hard-drive cluster size.                        *)
  LargeCluster = 2048;

                   (* Used to handle file-dates.                            *)
  ThisCentury = 1900;
  NextCentury = 2000;

                   (* Byte-size for XxHeader, includes 1 CrLf.              *)
  XxHeaderSize = 62;

                   (* Useable buffer sizes.                                 *)
  XxBuffSize  = 20400;
  BinBuffSize = 15300;

                   (* Maximum binary filesize.                              *)
  MaxFileSize = 999999;

                   (* Used to indicate an invalid longint.                  *)
  BadNumber = -1111111111;

(************************ PRE-INITIALIZED VARIABLES *************************)

                   (* Used to indicate if program is encoding or decoding.  *)
  Encoding     : boolean = false;

                   (* File attribute indicators.                            *)
  ReadOnlyIn   : boolean = false;
  ReadOnlyOut  : boolean = false;

                   (* Used to indicate if files are open.                   *)
  InFileOpen   : boolean = false;
  OutFileOpen  : boolean = false;

                   (* Used to indicate that the decoded file is invalid.    *)
  EraseOutFile : boolean = false;

                   (* Error-checking bytes.                                 *)
  FileDateFailByte    : byte = 0;
  FileNameFailByte    : byte = 0;
  FileSizeFailByte    : byte = 0;
  XxBlockSizeFailByte : byte = 0;

                   (* Carridge-return + Line-feed variables.                *)
  CrLf  : Char2 = #13#10;
  CrLf2 : Char4 = #13#10#13#10;
  CrLf3 : Char6 = #13#10#13#10#13#10;

                   (* Initial XxBlock delimiter.                            *)
  XxBlockID : Char7 = '*XX3401';

                   (* Alternative-delimiter set.                            *)
  AdSet : Char9 = ':#@=$?%&!';

                   (* Look-up string to determine which Alternative-        *)
                   (* delimiter to use.                                     *)
  AdString : Str27 = 'AD1AD2AD3AD4AD5AD6AD7AD8AD9';

                   (* XxBlock "footer".                                     *)
  XxEndMarker : Str33 = '***** END OF XX-BLOCK *****' + #13#10#13#10#13#10;

                             (* XxHeader array-type variable.               *)
  XxHeader1 : Head1 =
     '*XX3401-000000-000000--68--85-00000--------------------OF---' + #13#10;

                   (* Set of standard Xx characters.                        *)
  XxSet : Char64 =
          '+-0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz';

                  (* Xx-character to Binary-Byte translation/look-up table. *)
  BinSet : Byte80 = ( 0,  0,  1,  0,  0,  2,  3,  4,  5,  6,
                      7,  8,  9, 10, 11,  0,  0,  0,  0,  0,
                      0,  0, 12, 13, 14, 15, 16, 17, 18, 19,
                     20, 21, 22, 23, 24, 25, 26, 27, 28, 29,
                     30, 31, 32, 33, 34, 35, 36, 37,  0,  0,
                      0,  0,  0,  0, 38, 39, 40, 41, 42, 43,
                     44, 45, 46, 47, 48, 49, 50, 51, 52, 53,
                     54, 55, 56, 57, 58, 59, 60, 61, 62, 63);

                   (* Char2 to number translation/look-up table.            *)
  NumTable : Char303 =
              ((Num:'00'; Dud:'|'), (Num:'01'; Dud:'|'), (Num:'02'; Dud:'|'),
               (Num:'03'; Dud:'|'), (Num:'04'; Dud:'|'), (Num:'05'; Dud:'|'),
               (Num:'06'; Dud:'|'), (Num:'07'; Dud:'|'), (Num:'08'; Dud:'|'),
               (Num:'09'; Dud:'|'), (Num:'10'; Dud:'|'), (Num:'11'; Dud:'|'),
               (Num:'12'; Dud:'|'), (Num:'13'; Dud:'|'), (Num:'14'; Dud:'|'),
               (Num:'15'; Dud:'|'), (Num:'16'; Dud:'|'), (Num:'17'; Dud:'|'),
               (Num:'18'; Dud:'|'), (Num:'19'; Dud:'|'), (Num:'20'; Dud:'|'),
               (Num:'21'; Dud:'|'), (Num:'22'; Dud:'|'), (Num:'23'; Dud:'|'),
               (Num:'24'; Dud:'|'), (Num:'25'; Dud:'|'), (Num:'26'; Dud:'|'),
               (Num:'27'; Dud:'|'), (Num:'28'; Dud:'|'), (Num:'29'; Dud:'|'),
               (Num:'30'; Dud:'|'), (Num:'31'; Dud:'|'), (Num:'32'; Dud:'|'),
               (Num:'33'; Dud:'|'), (Num:'34'; Dud:'|'), (Num:'35'; Dud:'|'),
               (Num:'36'; Dud:'|'), (Num:'37'; Dud:'|'), (Num:'38'; Dud:'|'),
               (Num:'39'; Dud:'|'), (Num:'40'; Dud:'|'), (Num:'41'; Dud:'|'),
               (Num:'42'; Dud:'|'), (Num:'43'; Dud:'|'), (Num:'44'; Dud:'|'),
               (Num:'45'; Dud:'|'), (Num:'46'; Dud:'|'), (Num:'47'; Dud:'|'),
               (Num:'48'; Dud:'|'), (Num:'49'; Dud:'|'), (Num:'50'; Dud:'|'),
               (Num:'51'; Dud:'|'), (Num:'52'; Dud:'|'), (Num:'53'; Dud:'|'),
               (Num:'54'; Dud:'|'), (Num:'55'; Dud:'|'), (Num:'56'; Dud:'|'),
               (Num:'57'; Dud:'|'), (Num:'58'; Dud:'|'), (Num:'59'; Dud:'|'),
               (Num:'60'; Dud:'|'), (Num:'61'; Dud:'|'), (Num:'62'; Dud:'|'),
               (Num:'63'; Dud:'|'), (Num:'64'; Dud:'|'), (Num:'65'; Dud:'|'),
               (Num:'66'; Dud:'|'), (Num:'67'; Dud:'|'), (Num:'68'; Dud:'|'),
               (Num:'69'; Dud:'|'), (Num:'70'; Dud:'|'), (Num:'71'; Dud:'|'),
               (Num:'72'; Dud:'|'), (Num:'73'; Dud:'|'), (Num:'74'; Dud:'|'),
               (Num:'75'; Dud:'|'), (Num:'76'; Dud:'|'), (Num:'77'; Dud:'|'),
               (Num:'78'; Dud:'|'), (Num:'79'; Dud:'|'), (Num:'80'; Dud:'|'),
               (Num:'81'; Dud:'|'), (Num:'82'; Dud:'|'), (Num:'83'; Dud:'|'),
               (Num:'84'; Dud:'|'), (Num:'85'; Dud:'|'), (Num:'86'; Dud:'|'),
               (Num:'87'; Dud:'|'), (Num:'88'; Dud:'|'), (Num:'89'; Dud:'|'),
               (Num:'90'; Dud:'|'), (Num:'91'; Dud:'|'), (Num:'92'; Dud:'|'),
               (Num:'93'; Dud:'|'), (Num:'94'; Dud:'|'), (Num:'95'; Dud:'|'),
               (Num:'96'; Dud:'|'), (Num:'97'; Dud:'|'), (Num:'98'; Dud:'|'),
               (Num:'99'; Dud:'|'), (Num:'10'; Dud:'0'));

                   (* Char3 to number translation/look-up table.            *)
  RowColTable : Char800 =
           ((Num:'--1'; Dud:'|'), (Num:'--2'; Dud:'|'), (Num:'--3'; Dud:'|'),
            (Num:'--4'; Dud:'|'), (Num:'--5'; Dud:'|'), (Num:'--6'; Dud:'|'),
            (Num:'--7'; Dud:'|'), (Num:'--8'; Dud:'|'), (Num:'--9'; Dud:'|'),
            (Num:'-10'; Dud:'|'), (Num:'-11'; Dud:'|'), (Num:'-12'; Dud:'|'),
            (Num:'-13'; Dud:'|'), (Num:'-14'; Dud:'|'), (Num:'-15'; Dud:'|'),
            (Num:'-16'; Dud:'|'), (Num:'-17'; Dud:'|'), (Num:'-18'; Dud:'|'),
            (Num:'-19'; Dud:'|'), (Num:'-20'; Dud:'|'), (Num:'-21'; Dud:'|'),
            (Num:'-22'; Dud:'|'), (Num:'-23'; Dud:'|'), (Num:'-24'; Dud:'|'),
            (Num:'-25'; Dud:'|'), (Num:'-26'; Dud:'|'), (Num:'-27'; Dud:'|'),
            (Num:'-28'; Dud:'|'), (Num:'-29'; Dud:'|'), (Num:'-30'; Dud:'|'),
            (Num:'-31'; Dud:'|'), (Num:'-32'; Dud:'|'), (Num:'-33'; Dud:'|'),
            (Num:'-34'; Dud:'|'), (Num:'-35'; Dud:'|'), (Num:'-36'; Dud:'|'),
            (Num:'-37'; Dud:'|'), (Num:'-38'; Dud:'|'), (Num:'-39'; Dud:'|'),
            (Num:'-40'; Dud:'|'), (Num:'-41'; Dud:'|'), (Num:'-42'; Dud:'|'),
            (Num:'-43'; Dud:'|'), (Num:'-44'; Dud:'|'), (Num:'-45'; Dud:'|'),
            (Num:'-46'; Dud:'|'), (Num:'-47'; Dud:'|'), (Num:'-48'; Dud:'|'),
            (Num:'-49'; Dud:'|'), (Num:'-50'; Dud:'|'), (Num:'-51'; Dud:'|'),
            (Num:'-52'; Dud:'|'), (Num:'-53'; Dud:'|'), (Num:'-54'; Dud:'|'),
            (Num:'-55'; Dud:'|'), (Num:'-56'; Dud:'|'), (Num:'-57'; Dud:'|'),
            (Num:'-58'; Dud:'|'), (Num:'-59'; Dud:'|'), (Num:'-60'; Dud:'|'),
            (Num:'-61'; Dud:'|'), (Num:'-62'; Dud:'|'), (Num:'-63'; Dud:'|'),
            (Num:'-64'; Dud:'|'), (Num:'-65'; Dud:'|'), (Num:'-66'; Dud:'|'),
            (Num:'-67'; Dud:'|'), (Num:'-68'; Dud:'|'), (Num:'-69'; Dud:'|'),
            (Num:'-70'; Dud:'|'), (Num:'-71'; Dud:'|'), (Num:'-72'; Dud:'|'),
            (Num:'-73'; Dud:'|'), (Num:'-74'; Dud:'|'), (Num:'-75'; Dud:'|'),
            (Num:'-76'; Dud:'|'), (Num:'-77'; Dud:'|'), (Num:'-78'; Dud:'|'),
            (Num:'-79'; Dud:'|'), (Num:'-80'; Dud:'|'), (Num:'-81'; Dud:'|'),
            (Num:'-82'; Dud:'|'), (Num:'-83'; Dud:'|'), (Num:'-84'; Dud:'|'),
            (Num:'-85'; Dud:'|'), (Num:'-86'; Dud:'|'), (Num:'-87'; Dud:'|'),
            (Num:'-88'; Dud:'|'), (Num:'-89'; Dud:'|'), (Num:'-90'; Dud:'|'),
            (Num:'-91'; Dud:'|'), (Num:'-92'; Dud:'|'), (Num:'-93'; Dud:'|'),
            (Num:'-94'; Dud:'|'), (Num:'-95'; Dud:'|'), (Num:'-96'; Dud:'|'),
            (Num:'-97'; Dud:'|'), (Num:'-98'; Dud:'|'), (Num:'-99'; Dud:'|'),
            (Num:'100'; Dud:'|'), (Num:'101'; Dud:'|'), (Num:'102'; Dud:'|'),
            (Num:'103'; Dud:'|'), (Num:'104'; Dud:'|'), (Num:'105'; Dud:'|'),
            (Num:'106'; Dud:'|'), (Num:'107'; Dud:'|'), (Num:'108'; Dud:'|'),
            (Num:'109'; Dud:'|'), (Num:'110'; Dud:'|'), (Num:'111'; Dud:'|'),
            (Num:'112'; Dud:'|'), (Num:'113'; Dud:'|'), (Num:'114'; Dud:'|'),
            (Num:'115'; Dud:'|'), (Num:'116'; Dud:'|'), (Num:'117'; Dud:'|'),
            (Num:'118'; Dud:'|'), (Num:'119'; Dud:'|'), (Num:'120'; Dud:'|'),
            (Num:'121'; Dud:'|'), (Num:'122'; Dud:'|'), (Num:'123'; Dud:'|'),
            (Num:'124'; Dud:'|'), (Num:'125'; Dud:'|'), (Num:'126'; Dud:'|'),
            (Num:'127'; Dud:'|'), (Num:'128'; Dud:'|'), (Num:'129'; Dud:'|'),
            (Num:'130'; Dud:'|'), (Num:'131'; Dud:'|'), (Num:'132'; Dud:'|'),
            (Num:'133'; Dud:'|'), (Num:'134'; Dud:'|'), (Num:'135'; Dud:'|'),
            (Num:'136'; Dud:'|'), (Num:'137'; Dud:'|'), (Num:'138'; Dud:'|'),
            (Num:'139'; Dud:'|'), (Num:'140'; Dud:'|'), (Num:'141'; Dud:'|'),
            (Num:'142'; Dud:'|'), (Num:'143'; Dud:'|'), (Num:'144'; Dud:'|'),
            (Num:'145'; Dud:'|'), (Num:'146'; Dud:'|'), (Num:'147'; Dud:'|'),
            (Num:'148'; Dud:'|'), (Num:'149'; Dud:'|'), (Num:'150'; Dud:'|'),
            (Num:'151'; Dud:'|'), (Num:'152'; Dud:'|'), (Num:'153'; Dud:'|'),
            (Num:'154'; Dud:'|'), (Num:'155'; Dud:'|'), (Num:'156'; Dud:'|'),
            (Num:'157'; Dud:'|'), (Num:'158'; Dud:'|'), (Num:'159'; Dud:'|'),
            (Num:'160'; Dud:'|'), (Num:'161'; Dud:'|'), (Num:'162'; Dud:'|'),
            (Num:'163'; Dud:'|'), (Num:'164'; Dud:'|'), (Num:'165'; Dud:'|'),
            (Num:'166'; Dud:'|'), (Num:'167'; Dud:'|'), (Num:'168'; Dud:'|'),
            (Num:'169'; Dud:'|'), (Num:'170'; Dud:'|'), (Num:'171'; Dud:'|'),
            (Num:'172'; Dud:'|'), (Num:'173'; Dud:'|'), (Num:'174'; Dud:'|'),
            (Num:'175'; Dud:'|'), (Num:'176'; Dud:'|'), (Num:'177'; Dud:'|'),
            (Num:'178'; Dud:'|'), (Num:'179'; Dud:'|'), (Num:'180'; Dud:'|'),
            (Num:'181'; Dud:'|'), (Num:'182'; Dud:'|'), (Num:'183'; Dud:'|'),
            (Num:'184'; Dud:'|'), (Num:'185'; Dud:'|'), (Num:'186'; Dud:'|'),
            (Num:'187'; Dud:'|'), (Num:'188'; Dud:'|'), (Num:'189'; Dud:'|'),
            (Num:'190'; Dud:'|'), (Num:'191'; Dud:'|'), (Num:'192'; Dud:'|'),
            (Num:'193'; Dud:'|'), (Num:'194'; Dud:'|'), (Num:'195'; Dud:'|'),
            (Num:'196'; Dud:'|'), (Num:'197'; Dud:'|'), (Num:'198'; Dud:'|'),
            (Num:'199'; Dud:'|'), (Num:'200'; Dud:'|'));

var
                   (* Error checking booleans.                              *)
  FileDateFail    : boolean absolute FileDateFailByte;
  FileNameFail    : boolean absolute FileNameFailByte;
  FileSizeFail    : boolean absolute FileSizeFailByte;
  XxBlockSizeFail : boolean absolute XxBlockSizeFailByte;

                             (* Same variable but in record-type format.    *)
  XxHeader2 : Head2 absolute XxHeader1;

(************************ UN-INITIALIZED VARIABLES **************************)

  XxBuffIndex,               (* XxBuffer variables.                         *)
  XxBuffOffset,
  BytesInXxBuff,

  BinBuffIndex,              (* BinaryBuffer variables.                     *)
  BinBuffOffset,
  BinBytesToWrite,

  XxBlockIndex,              (* XxBlock variables.                          *)
  XxBlockSize,

  BinBlockSize,
  BinBlockIndex,             (* BinaryBlock variables.                      *)

  Fattr,                     (* Generic file-attribute                      *)

  TempRowSize,               (* Temporary XxBlock row height size.          *)
  TempColSize,               (* Temporary XxBlock Column width size.        *)

  TempBlockNum,              (* Temporary XxBlock number.                   *)
  TempBlockTotal,            (* Temporary total number of XxBlocks.         *)

  MaxBlockTotal,             (* Largest block-total value in XxHeaders.     *)

  LineIndex,                 (* Line number being processed.                *)

  BytesToGet,                (* Number of bytes to read in and process.     *)

  XxBlockFound : word;       (* Number of XxBlocks found.                   *)

  TempIndex1,                (* Generic temporary-indexes.                  *)
  TempIndex2,

  XxFilesize,                (* Size of XxFile in bytes.                    *)
  XxFileIndex,               (* XxFile position index.                      *)

  BinFilesize,               (* Size of BinaryFile in bytes.                *)
  BinFileIndex,              (* BinaryFile position index.                  *)

  TempBlockSize,             (* Temporary XxBlock size in bytes.            *)

  HeaderPos,                 (* Position of the XxHeader in the XxBuffer.   *)
  NonXxIndex,                (* Non Xx-character index.                     *)
  FileTime,                  (* FileTime variable.                          *)
  TempBinFilesize : longint; (* Temporary BinaryFile size in bytes.         *)

  FileDate : datetime;       (* FileDate variables.                         *)

  TempFileDate,
  BinFileDate : Char3x2;     (* Variable to check the XxHeader filedate.    *)

  TempStr1,                  (* Temporary string variables.                 *)
  TempStr2  : Str12;

  InFilename,                (* Filename of InFile.                         *)
  OutFilename,               (* Filename of OutFile.                        *)
  TempFilename : FnType;     (* Temporary filename taken from the XxHeader. *)

  PBlockOrder,               (* Physical order of XxBlocks.                 *)
  BlockTotRec,               (* An array of the XxBlock-total's encoded.    *)
  BlockNumRec : Byte100;     (* An array of the XxBlock-number's encoded.   *)

  CrcRec,                    (* An array of XxBlock Crc values.             *)
  PBlockSize,                (* An array of physical XxBlock sizes.         *)
  BuffBlockPos : Word99;     (* An array of XxBlock buffer positions.       *)

  XxBlockPos,                (* An array of XxBlock file positions.         *)
  XxBlockSizeRec : Long99;   (* An array of XxHeader XxBlock sizes.         *)

  InFile,                    (* File variable for in-file.                  *)
  OutFile : file;            (* File variable for out-file.                 *)

  BinBuffer  : BinBuffType;  (* Binary-buffer variable.                     *)
  XxBuffer   : XxBuffType;   (* XxBuffer variable.                          *)

(************************ END OF DATA STRUCTURES ****************************)


  procedure InitXx34;


IMPLEMENTATION

                   (* Initialize variables.                                 *)
  procedure InitXx34;
  begin
    BinBlockSize    := 0;
    BinBuffIndex    := 0;
    BinBytesToWrite := 0;
    BinFileIndex    := 0;
    BinFilesize     := 0;
    BytesInXxBuff   := 0;
    BytesToGet      := 0;
    Fattr           := 0;
    FileTime        := 0;
    HeaderPos       := 0;
    LineIndex       := 0;
    MaxBlockTotal   := 0;
    NonXxIndex      := 0;
    TempBinFileSize := 0;
    TempBlockNum    := 0;
    TempBlockSize   := 0;
    TempBlockTotal  := 0;
    TempColSize     := ColDefault;
    TempRowSize     := RowDefault;
    XxBlockFound    := 0;
    XxBlockIndex    := 0;
    XxBlockSize     := 0;
    XxBuffIndex     := 0;
    XxBuffOffset    := 0;
    XxFileIndex     := 0;
    XxFilesize      := 0;
    fillchar(BinFileDate,    sizeof(BinFileDate),    0);
    fillchar(BlockNumRec,    sizeof(BlockNumRec),    0);
    fillchar(BlockTotRec,    sizeof(BlockTotRec),    0);
    fillchar(BuffBlockPos,   sizeof(BuffBlockPos),   0);
    fillchar(CrcRec,         sizeof(CrcRec),         0);
    fillchar(FileDate,       sizeof(FileDate),       0);
    fillchar(InFilename,     sizeof(InFilename),     0);
    fillchar(OutFilename,    sizeof(OutFilename),    0);
    fillchar(PBlockOrder,    sizeof(PBlockOrder),    0);
    fillchar(PBlockSize,     sizeof(PBlockSize),     0);
    fillchar(TempFileDate,   sizeof(TempFileDate),   0);
    fillchar(TempFilename,   sizeof(TempFilename),   0);
    fillchar(TempStr1,       sizeof(TempStr1),       0);
    fillchar(TempStr2,       sizeof(TempStr2),       0);
    fillchar(XxBlockPos,     sizeof(XxBlockPos),     0);
    fillchar(XxBlockSize,    sizeof(XxBlockSize),    0);
    fillchar(XxBlockSizeRec, sizeof(XxBlockSizeRec), 0);
    fillchar(BinBuffer,      sizeof(BinBuffer),      0);
    fillchar(XxBuffer,       sizeof(XxBuffer),       0)
  end;

END.

