
                   (* Routines unit for XX3401.PAS.                         *)
UNIT Xx34Rout;

INTERFACE

uses
  Xx34Data,
  Crc;

                  (* Convert a number string to an integer-type number.     *)
  function Str2Num(var InStr; Size : byte): longint;

                 (* Convert an integer-type number to a number string.      *)
  function Num2Str(InNum : longint; Size : byte) : string;

                 (* Covert a string to upper-case.                          *)
  function UpStr(InString : string) : string;

                 (* Convert "old-characters" to "new-characters".           *)
  function ConvertChar(InStr : string; OldChar, NewChar : char) : string;

                 (* Answer "YES" or "NO" routine. Crt-unit not needed.      *)
  function YesNo : boolean;

                 (* Calculate 16-bit Crc-value.                             *)
  function CalcCrc : word;


IMPLEMENTATION

(*  const
      BadNumber = -1111111111;   Defined in Xx34Data  *)

  function Str2Num(var InStr; Size : byte): longint;
  var
    Error    : integer;
    TempLong : longint;
    TempStr  : string;
  begin
    TempStr[0] := chr(Size);
    move(InStr, TempStr[1], Size);
    val(TempStr, TempLong, Error);
    if (Error <> 0) then
      Str2Num := BadNumber
    else
      Str2Num := TempLong
  end;


  function Num2Str(InNum : longint; Size : byte) : string;
  var
    TempStr : Str12;
  begin
    str(InNum:Size, TempStr);
    Num2Str := TempStr
  end;


  function UpStr(InString : string) : string;
  var
    Index : byte;
    TempStr : string;
  begin
    TempStr[0] := InString[0];
    for Index := 1 to length(InString) do
      TempStr[Index] := upcase(InString[Index]);
    UpStr := TempStr
  end;


  function ConvertChar(InStr : string; OldChar, NewChar : char) : string;
  var
    TempStr : string;
  begin
    TempStr := InStr;
    while (pos(OldChar, TempStr) <> 0) do
      TempStr[pos(OldChar, TempStr)] := NewChar;
    ConvertChar := TempStr
  end;


  function KeyPressed : boolean;
  var IsThere : byte;
  begin
    inline($B4/$0B/$CD/$21/$88/$86/>IsThere);
    if (IsThere = $FF) then
      KeyPressed := true
    else
      KeyPressed := false
  end;


  function ReadKey : char;
  var chrout : char;
  begin
    inline($B4/$07/$CD/$21/$88/$86/>chrout);
    ReadKey := chrout
  end;


  function YesNo : boolean;
  var
    Key : char;
  begin
    while keypressed do
      Key := readkey;
    repeat
      Key := upcase(readkey)
    until (Key in ['N', 'Y']);
    if (Key = 'N') then
      YesNo := false
    else
      YesNo := true
  end;


  function CalcCrc : word;
  var
    CrcNum : word;
  begin
    CrcNum := 0;
    if Encoding then
      CrcNum := UpdateCrc16(CrcNum, BinBuffer[BinBuffIndex + 1], BinBlockSize)
    else
      CrcNum := UpdateCrc16(CrcNum,
                  BinBuffer[(BinBuffIndex - BinBlockSize) + 1], BinBlockSize);
    CalcCrc := CrcNum
  end;

END.

